// -*- C++ -*-
//
// Copyright (C) 1998, 1999, 2000, 2002  Los Alamos National Laboratory,
// Copyright (C) 1998, 1999, 2000, 2002  CodeSourcery, LLC
//
// This file is part of FreePOOMA.
//
// FreePOOMA is free software; you can redistribute it and/or modify it
// under the terms of the Expat license.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Expat
// license for more details.
//
// You should have received a copy of the Expat license along with
// FreePOOMA; see the file LICENSE.
//

#ifndef POOMA_POOMA_DYNAMICARRAYS_H
#define POOMA_POOMA_DYNAMICARRAYS_H

/** @file
 * @ingroup Pooma
 * @brief
 * A one-stop-shopping header file that sets up everything one needs to use
 * all Pooma II DynamicArray's with Tiny things, complex numbers, and
 * other Arrays.
 */

// Include files

#include "Pooma/Pooma.h"

#include "DynamicArray/DynamicArray.h"
#include "Engine/DynamicEngine.h"
#include "Engine/MultiPatchEngine.h"
#include "Engine/RemoteDynamicEngine.h"
#include "Layout/DynamicLayout.h"

#include "Pooma/Tiny.h"
#include <complex>

#endif

// ACL:rcsinfo
// ----------------------------------------------------------------------
// $RCSfile: DynamicArrays.h,v $   $Author: richard $
// $Revision: 1.11 $   $Date: 2004/11/01 18:17:03 $
// ----------------------------------------------------------------------
// ACL:rcsinfo
